/*

		Name.........GFAHELP.EXE
		By...........R.de Pauw
		In...........Turbo C++
		Date.........28 mar 94
		Options......Tiny memory model

		This program gives online help about the
		command the cursor is placed on.
		Use with	POPUP.EXE TSR by pressing <alt> +

*/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>

#define	HELPTEXT "GFAHELP.TXT"
#define	HELPINDEX "GFAHELP.IDX"

int	lees_woord(void);
long 	zoek_index(void);
void	show_help(long  ptr);

int	directvideo=1;         // Write to Video RAM
char	buffer[200];
char	woord[40];

void main(void)
{
	long 		ptr=0;			// See unsigned
	int		i;
	i=lees_woord();
	clrscr();
	textcolor(LIGHTCYAN);
	cprintf("GFAHELP ");

	if (i>0)
		{
//		cprintf("Searching %s ",woord);
		ptr=zoek_index();
		if (ptr>0) show_help(ptr);
		}

	if (ptr<1) cprintf("Not found");
	getch();
}

int	lees_woord(void)		// Get woord from GFA-screen
{
	int		i,n,cx,cy;
	char		ch;
	cx=wherex();
	cy=wherey();
	gettext(1, cy, 80, cy, buffer);			// Screenline (160 bytes !)
	i=2*(cx-1);

	while(i>0)              // Scan left while valid char
		{
		ch=buffer[i-2];
		if (ch<'@') break;
		if (ch!='_' && ch>'z') break;
		i=i-2;
		}

	n=0;
	while(n<30 && i<158)		// Scan Right
		{
		ch=buffer[i];
		if (ch<32 || ch>126) break;	// Valid char ' ' to '~'
		woord[n]=ch;
		i=i+2;
		n++;
		}
	woord[n]=0;
	return n;     // Return chars read
}

long 	zoek_index(void)		// Search woord in indexfile
{
	FILE		*idx;
	char		keyword[40];
	char		pointer[20];
	long 		ptr=0;
	int		lines=0, len=0;

	idx=fopen(HELPINDEX, "r");
	if (idx==NULL)	{
		cprintf("*** GFAHELP.IDX not found ***\n\r");
		return 0;	}

	while (!feof(idx)) {                     // Compare with Keywords
		fgets(keyword,38,idx);
		fgets(pointer,10,idx);
//		lines++;
//		if (lines>16) {lines=0; getch();}
//		cprintf("%s %s\n\r",keyword,pointer);
		len=strlen(keyword)-1;									// Do not count fgets LF
		if (strncmpi(keyword,woord,len)==0) break;	}     // Found !

	if (!feof(idx)) ptr=atol(pointer)+1;
	fclose(idx);
	return ptr;
}

void	show_help(long  ptr)		// Show helptext for command
{
	FILE		*txt;
	int		lines=0;
	txt=fopen(HELPTEXT, "r");
	fseek(txt,ptr,SEEK_SET);      // Set filepointer at #command
	textcolor(YELLOW);
	fgets(buffer,80,txt);			// Read max 80 chars
	cprintf("%s\n\r",buffer);		// Command in yellow
	textcolor(LIGHTCYAN);

	while (!feof(txt))
		{
		if (lines>19)              // <More> after 20 lines
			{
			textcolor(LIGHTGREEN);
			cprintf(" <More>\r");
			getch();
			textcolor(LIGHTCYAN);
			lines=0;
			}
		fgets(buffer,80,txt);			// Read max 80 chars
		if (buffer[0]=='#') break;    // Until next #command
		cprintf("%s\r",buffer);
		lines++;
		}
	fclose(txt);
}

// The END